Qwt User's Guide 6.0.2

- Main Page
- Related Pages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Member Functions
QwtSlider Class Reference

`#include <qwt_slider.h>`

Inheritance diagram for QwtSlider:
[legend]

List of all members.

## Public Types
enum | BackgroundStyle { Trough = 0x01, Groove = 0x02 }
typedef QFlags< BackgroundStyle > | BackgroundStyles
enum | ScalePos { NoScale, LeftScale, RightScale, TopScale, BottomScale }
Public Types inherited from QwtAbstractSlider
enum | ScrollMode { ScrNone, ScrMouse, ScrTimer, ScrDirect, ScrPage }

## Public Member Functions
| QwtSlider (QWidget *parent, Qt::Orientation=Qt::Horizontal, ScalePos=NoScale, BackgroundStyles=Trough)
BackgroundStyles | backgroundStyle () const
int | borderWidth () const
QSize | handleSize () const
virtual QSize | minimumSizeHint () const
const QwtScaleDraw * | scaleDraw () const
ScalePos | scalePosition () const
void | setBackgroundStyle (BackgroundStyles)
void | setBorderWidth (int bw)
void | setHandleSize (int width, int height)
void | setHandleSize (const QSize &)
virtual void | setOrientation (Qt::Orientation)
void | setScaleDraw (QwtScaleDraw *)
void | setScalePosition (ScalePos s)
void | setSpacing (int)
virtual QSize | sizeHint () const
int | spacing () const
Public Member Functions inherited from QwtAbstractSlider
| QwtAbstractSlider (Qt::Orientation, QWidget *parent=NULL)
virtual | ~QwtAbstractSlider ()
bool | isReadOnly () const
bool | isValid () const
virtual double | mass () const
Qt::Orientation | orientation () const
virtual void | setMass (double val)
void | setTracking (bool enable)
void | setUpdateTime (int t)
void | setValid (bool valid)
void | stopMoving ()
Public Member Functions inherited from QwtDoubleRange
| QwtDoubleRange ()
virtual | ~QwtDoubleRange ()
virtual void | incPages (int)
double | maxValue () const
double | minValue () const
int | pageSize () const
bool | periodic () const
void | setPeriodic (bool tf)
void | setRange (double vmin, double vmax, double vstep=0.0, int pagesize=1)
void | setStep (double)
double | step () const
double | value () const
Public Member Functions inherited from QwtAbstractScale
| QwtAbstractScale ()
virtual | ~QwtAbstractScale ()
bool | autoScale () const
const QwtScaleEngine * | scaleEngine () const
QwtScaleEngine * | scaleEngine ()
const QwtScaleMap & | scaleMap () const
int | scaleMaxMajor () const
int | scaleMaxMinor () const
void | setAutoScale ()
void | setScale (double vmin, double vmax, double step=0.0)
void | setScale (const QwtInterval &, double step=0.0)
void | setScale (const QwtScaleDiv &)
void | setScaleEngine (QwtScaleEngine *)
void | setScaleMaxMajor (int ticks)
void | setScaleMaxMinor (int ticks)

## Protected Member Functions
virtual void | changeEvent (QEvent *)
virtual void | drawHandle (QPainter *, const QRect &, int pos) const
virtual void | drawSlider (QPainter *, const QRect &) const
virtual void | getScrollMode (const QPoint &p, QwtAbstractSlider::ScrollMode &, int &direction) const
virtual double | getValue (const QPoint &p)
virtual void | paintEvent (QPaintEvent *)
virtual void | rangeChange ()
virtual void | resizeEvent (QResizeEvent *)
virtual void | scaleChange ()
QwtScaleDraw * | scaleDraw ()
int | transform (double v) const
virtual void | valueChange ()
Protected Member Functions inherited from QwtAbstractSlider
virtual void | keyPressEvent (QKeyEvent *e)
virtual void | mouseMoveEvent (QMouseEvent *e)
double | mouseOffset () const
virtual void | mousePressEvent (QMouseEvent *e)
virtual void | mouseReleaseEvent (QMouseEvent *e)
int | scrollMode () const
void | setMouseOffset (double)
virtual void | setPosition (const QPoint &)
virtual void | timerEvent (QTimerEvent *e)
virtual void | wheelEvent (QWheelEvent *e)
Protected Member Functions inherited from QwtDoubleRange
double | exactPrevValue () const
double | exactValue () const
double | prevValue () const
virtual void | stepChange ()
Protected Member Functions inherited from QwtAbstractScale
const QwtAbstractScaleDraw * | abstractScaleDraw () const
QwtAbstractScaleDraw * | abstractScaleDraw ()
void | rescale (double vmin, double vmax, double step=0.0)
void | setAbstractScaleDraw (QwtAbstractScaleDraw *)

## Additional Inherited Members
Public Slots inherited from QwtAbstractSlider
virtual void | fitValue (double val)
virtual void | incValue (int steps)
virtual void | setReadOnly (bool)
virtual void | setValue (double val)
Signals inherited from QwtAbstractSlider
void | sliderMoved (double value)
void | sliderPressed ()
void | sliderReleased ()
void | valueChanged (double value)

## Detailed Description

The Slider Widget.

QwtSlider is a slider widget which operates on an interval of type double. QwtSlider supports different layouts as well as a scale.

See also:
  QwtAbstractSlider and QwtAbstractScale for the descriptions of the inherited members.

## Member Enumeration Documentation

enum QwtSlider::BackgroundStyle

Background style.

See also:
  QwtSlider()

Enumerator:

  Trough | Trough background.
  Groove | Groove.

enum QwtSlider::ScalePos

Scale position. QwtSlider tries to enforce valid combinations of its orientation and scale position:

- Qt::Horizonal combines with NoScale, TopScale and BottomScale
- Qt::Vertical combines with NoScale, LeftScale and RightScale

See also:
  QwtSlider()

Enumerator:

  NoScale | The slider has no scale.
  LeftScale | The scale is left of the slider.
  RightScale | The scale is right of the slider.
  TopScale | The scale is above of the slider.
  BottomScale | The scale is below of the slider.

## Constructor & Destructor Documentation

QwtSlider::QwtSlider | ( | QWidget * | parent,
|  | Qt::Orientation | orientation = `Qt::Horizontal`,
|  | ScalePos | scalePos = `NoScale`,
|  | BackgroundStyles | bgStyle = `Trough`
| ) |  |
| explicit

Constructor.

Parameters:

  parent | parent widget
  orientation | Orientation of the slider. Can be Qt::Horizontal or Qt::Vertical. Defaults to Qt::Horizontal.
  scalePos | Position of the scale. Defaults to QwtSlider::NoScale.
  bgStyle | Background style. QwtSlider::Trough draws the slider button in a trough, QwtSlider::Slot draws a slot underneath the button. An or-combination of both may also be used. The default is QwtSlider::Trough.

QwtSlider enforces valid combinations of its orientation and scale position. If the combination is invalid, the scale position will be set to NoScale. Valid combinations are:

- Qt::Horizonal with NoScale, TopScale, or BottomScale;
- Qt::Vertical with NoScale, LeftScale, or RightScale.

## Member Function Documentation

QwtSlider::BackgroundStyles QwtSlider::backgroundStyle | ( |  | ) | const

Returns:
  the background style.

int QwtSlider::borderWidth | ( |  | ) | const

Returns:
  the border width.

See also:
  setBorderWidth()

void QwtSlider::drawHandle | ( | QPainter * | painter,
|  | const QRect & | sliderRect,
|  | int | pos
| ) |  | const
| protected virtual

Draw the thumb at a position

Parameters:

  painter | Painter
  sliderRect | Bounding rectangle of the slider
  pos | Position of the slider thumb

void QwtSlider::drawSlider | ( | QPainter * | painter,
|  | const QRect & | sliderRect
| ) |  | const
| protected virtual

Draw the slider into the specified rectangle.

Parameters:

  painter | Painter
  sliderRect | Bounding rectangle of the slider

void QwtSlider::getScrollMode | ( | const QPoint & | p,
|  | QwtAbstractSlider::ScrollMode & | scrollMode,
|  | int & | direction
| ) |  | const
| protected virtual

Determine scrolling mode and direction.

Parameters:

  p | point
  scrollMode | Scrolling mode
  direction | Direction

Implements QwtAbstractSlider.

double QwtSlider::getValue | ( | const QPoint & | pos | ) |
| protected virtual

Determine the value corresponding to a specified mouse location.

Parameters:

  pos | Mouse position

Implements QwtAbstractSlider.

QSize QwtSlider::handleSize | ( |  | ) | const

Returns:
  Size of the handle.

See also:
  setHandleSize()

QSize QwtSlider::minimumSizeHint | ( |  | ) | const
| virtual

Return a minimum size hint.

Warning:
  The return value of QwtSlider::minimumSizeHint() depends on the font and the scale.

void QwtSlider::paintEvent | ( | QPaintEvent * | event | ) |
| protected virtual

Qt paint event

Parameters:

  event | Paint event

const QwtScaleDraw * QwtSlider::scaleDraw | ( |  | ) | const

Returns:
  the scale draw of the slider

See also:
  setScaleDraw()

QwtScaleDraw * QwtSlider::scaleDraw | ( |  | ) |
| protected

Returns:
  the scale draw of the slider

See also:
  setScaleDraw()

void QwtSlider::setBackgroundStyle | ( | BackgroundStyles | style | ) |

Set the background style.

void QwtSlider::setBorderWidth | ( | int | width | ) |

Change the slider's border width.

Parameters:

  width | Border width

void QwtSlider::setHandleSize | ( | int | width,
|  | int | height
| ) |  |

Set the slider's handle size.

Parameters:

  width | Width
  height | Height

See also:
  handleSize()

void QwtSlider::setHandleSize | ( | const QSize & | size | ) |

Set the slider's handle size.

Parameters:

  size | New size

See also:
  handleSize()

void QwtSlider::setOrientation | ( | Qt::Orientation | o | ) |
| virtual

Set the orientation.

Parameters:

  o | Orientation. Allowed values are Qt::Horizontal and Qt::Vertical.

If the new orientation and the old scale position are an invalid combination, the scale position will be set to QwtSlider::NoScale.

See also:
  QwtAbstractSlider::orientation()

Reimplemented from QwtAbstractSlider.

void QwtSlider::setScaleDraw | ( | QwtScaleDraw * | scaleDraw | ) |

Set a scale draw.

For changing the labels of the scales, it is necessary to derive from QwtScaleDraw and overload QwtScaleDraw::label().

Parameters:

  scaleDraw | ScaleDraw object, that has to be created with new and will be deleted in ~QwtSlider or the next call of setScaleDraw().

See also:
  scaleDraw()

void QwtSlider::setScalePosition | ( | ScalePos | scalePos | ) |

Change the scale position (and slider orientation).

Parameters:

  scalePos | Position of the scale.

A valid combination of scale position and orientation is enforced:

- if the new scale position is Left or Right, the scale orientation will become Qt::Vertical;
- if the new scale position is Bottom or Top the scale orientation will become Qt::Horizontal;
- if the new scale position is QwtSlider::NoScale, the scale orientation will not change.

void QwtSlider::setSpacing | ( | int | spacing | ) |

Change the spacing between pipe and scale.

A spacing of 0 means, that the backbone of the scale is below the trough.

The default setting is 4 pixels.

Parameters:

  spacing | Number of pixels

See also:
  spacing();

QSize QwtSlider::sizeHint | ( |  | ) | const
| virtual

Returns:
  QwtSlider::minimumSizeHint()

int QwtSlider::spacing | ( |  | ) | const

Returns:
  Number of pixels between slider and scale

See also:
  setSpacing()

int QwtSlider::transform | ( | double | value | ) | const
| protected

Map and round a value into widget coordinates

Parameters:

  value | Value